' FatBurn-Timer
' Eine nachhaltige Fettverbrennung auch Stunden nach dem Training 
' soll folgender Trainingsablauf bewirken:
' - sich 2 Minuten lang "verausgaben"
' - 1 Minute Erholung
' das ganze 6 mal wiederholen; Gesamtdauer also 21 Minuten
'
' Die Schaltung wird durch Druck auf die beiden Taster aufgeweckt, 
' erst Taster 2 druecken, dann zusaetzlich Taster 1
' Trainingsphase wird durch blinken von LED2 (rot) angezeigt 
' Ruhephase durch blinken von LED1 (grn)
' Nach 1 Minute erfolgt 1 Signalton, nach 2 Minuten 2 Signaltoene (Beginn Ruhephase),
' Nach 3 Minuten 3 Signaltoene  (Ende Ruhephase)
' nach 7 Zyklen langer Ton
' vorzeitiges Beenden durch Druecken von Taster1 > 2 Sekunden

' Compiler Bascom 2.0.7.5 DEMO
'----------------------------------------------------------

$regfile = "attiny13.dat"
$crystal = 1200000

$hwstack = 32
$swstack = 8
$framesize = 8

' Sicherstellen, dass Controller-Takt 1,2 MHz betraegt
Clkpr = 128                                                 ' Aenderung Clockteiler vorbereiten
Clkpr = 3                                                   ' 9600000 / 8
Clkpr = 3


'Variablen

Dim Ti As Byte
Dim Sekunde As Byte
Dim Minute As Byte
Dim Cntr As Byte
Dim N As Byte


Buzzer Alias Portb.4
Led1 Alias Portb.1                                          ' gruen, rechts
Led2 Alias Portb.3                                          ' rot, links
Taster1 Alias Pinb.0                                        ' links
Taster2 Alias Pinb.2                                        ' rechts

' Konstanten

Const Dit1 = 60                                             ' Laengen Sounds
Const Dit2 = 30
Const Dit3 = 600
Const Tonhoehe1 = 120
Const Tonhoehe2 = 160
Const Tonhoehe3 = 320


' Register

Didr0 = &B00011010                                          ' einige digitale Inputs abschalten (spart Strom)
Portb = &B00000101                                          ' Pullups fuer die beiden Taster
Ddrb = &B00011010
Acsr.7 = 1                                                  ' Analog-Komparator ausschalten, spart etwas Strom
Pcmsk.2 = 1                                                 ' Pin Change Interrupt PB2 auswhlen
Sreg.7 = 1                                                  ' Global Interrupt Enable
Gimsk.5 = 1                                                 ' Pin Change Interrupt Enable


Config Timer0 = Timer , Prescale = 256                      ' Ergibt 20 berlufe pro Sekunde, wenn der Timer nicht bei 0, sondern
                                                            ' bei 22 startet
On Timer0 Ontimer0                                          ' Interrupt-Routine


'----------------------------------------------------------

Do

    Gimsk.5 = 0
    If Taster1 = 0 Then 
        Ti = 0 : Sekunde = 0: Minute = 0 : Cntr = 0
        Enable Timer0
        Start Timer0
        Sound Buzzer , Dit1 , Tonhoehe1

        Do                                                  ' Hauptschleife
            If Ti > 18 Then                                 ' Sekunde um
               Ti = 0
               Incr Sekunde
            End If
            If Sekunde > 59 Then
                 Sekunde = 0
                Incr Minute
                For N = 1 To Minute
                   Gosub Snd1
                   Waitms 200
                Next
                If Minute > 2 Then 
                    Minute = 0
                    Incr Cntr
                End If
                If Cntr > 6 Then
                    Gosub Snd2  
                    Goto Schlafen
                End If
            End If
            If Taster1 = 0 Then
                Wait 2
                If Taster1 = 0 Then
                   Gosub Snd2
                   Goto Schlafen
                End If
            End If
            idle 
        Loop

    End if

Schlafen:
    Led1 = 0 : Led2 = 0
    Stop Timer0
    Gimsk.5 = 1
    Powerdown 

Loop



Snd1:
    Sound Buzzer , Dit1 , Tonhoehe1
    Sound Buzzer , Dit2 , Tonhoehe2
Return

Snd2:
    Sound Buzzer , Dit3 , Tonhoehe3
Return


'----------------------------------------------------------


Ontimer0:                                                   ' Timer0-Overflow-Interrupt-Routine

    Tcnt0 = 22                                               ' Preset auf 22, damit er 234 Takte bis Ueberlauf zhlt
    Incr Ti
    If Ti = 1 Then
        If Minute = 2 Then 
            Led1 = 1
        Else
            Led2 = 1
        End If
    Else
        Led1 = 0
        Led2 = 0
    End If

Return
